 /*
  * Khoros: $Id: vrect2pol.h,v 1.2 1992/03/20 23:04:08 dkhoros Exp $
  */

 /*
  * $Log: vrect2pol.h,v $
 * Revision 1.2  1992/03/20  23:04:08  dkhoros
 * VirtualPatch5
 *
  */

/*
 *----------------------------------------------------------------------
 *
 * Copyright 1992, University of New Mexico.  All rights reserved.
 * Permission to copy and modify this software and its documen-
 * tation only for internal use in your organization is hereby
 * granted, provided that this notice is retained thereon and
 * on all copies.  UNM makes no representations as to the sui-
 * tability and operability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 * 
 * UNM DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FIT-
 * NESS.  IN NO EVENT SHALL UNM BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY OTHER DAMAGES WHAT-
 * SOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER
 * IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
 * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PER-
 * FORMANCE OF THIS SOFTWARE.
 * 
 * No other rights, including, for example, the right to redis-
 * tribute this software and its documentation or the right to
 * prepare derivative works, are granted unless specifically
 * provided in a separate license agreement.
 *---------------------------------------------------------------------
 */

#include "unmcopyright.h"        /* Copyright 1992 by UNM */


/*>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
 >>>>
 >>>>         File Name: vrect2pol.h
 >>>>            Author: Ramiro Jordan, Jeremy Worley, Tom Sauer
 >>>> Date Last Updated: Mon Mar  9 18:46:47 1992
 >>>> 
 >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>   <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<*/

#ifndef _vrect2pol_h_
#define _vrect2pol_h_

#include "vinclude.h"


/* -include_includes */
/* -include_includes_end */

char	**av,		/* argv and argc used by gparams */
	*program;	/* a pointer to the program name argv[0] */
int	ac;

/****************************************************************
*
*                    vrect2pol Argument Structure
*
****************************************************************/

typedef struct _vrect2pol  {

/*
 *  input data file (xviff file) (Required infile)
 */
char	*i_file;	/* input data file (xviff file) FILENAME */
int	 i_flag;	/* input data file (xviff file) FLAG */

/*
 *  output data file (xviff file) (Required outfile)
 */
char	*o_file;	/* output data file (xviff file) FILENAME */
int	 o_flag;	/* output data file (xviff file) FLAG */

/*
 *  0 = Rect_to_Polar  1 = Polar_to_Rect (Optional logical)
 */
int	 c_logic;	/* 0 = Rect_to_Polar  1 = Polar_to_Rect LOGIC */
int	 c_flag;  	/* 0 = Rect_to_Polar  1 = Polar_to_Rect FLAG */

/*
 *  data processing direction (0 = down vectors, 1 = across bands) (Optional logical)
 */
int	 d_logic;	/* data processing direction (0 = down vectors, 1 = across bands) LOGIC */
int	 d_flag;  	/* data processing direction (0 = down vectors, 1 = across bands) FLAG */

}  vrect2pol_struct;

vrect2pol_struct *vrect2pol;

/* -include_additions */
/* -include_additions_end */

/* -include_macros */

#define READIMAGE(image) \
image = readimage(vrect2pol->i_file);  \
if (image == NULL) {  \
   (void) fprintf(stderr, "vrect2pol: Cannot read input image \n");  \
   exit(1);  /* Quit if bad image */ \
} 

#define CHECKTYPE(program, image) \
    if( ! (propertype(program,image,VFF_TYP_FLOAT,FALSE)) && \
        ! (propertype(program,image,VFF_TYP_COMPLEX,FALSE)) ) { \
          fprintf(stderr,"%s: data storage type must be integer, float or complex.",program); \
          exit(1); \
    }

#define CHECKINPUT(program, image) \
    proper_num_images(program,image,1,TRUE);  \
    proper_map_enable(program,image,VFF_MAP_OPTIONAL,TRUE)

/* -include_macros_end */

#endif
